package com.deserialization.lab;

import com.deserialization.lab.route.RouteBuilderImpl;

import org.apache.camel.CamelContext;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.commons.collections.FactoryUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;


public class Main
{

    public static void main(String[] args) throws InterruptedException
    {
        Logger logger = LogManager.getLogger();

        FactoryUtils utils;

        try
        {

            logger.info("Starting Java Deserialization Lab");
            CamelContext context = new DefaultCamelContext();
            context.addRoutes(new RouteBuilderImpl());

            context.start();

            logger.info("Starting Java Deserialization Lab");

        }
        catch (InterruptedException iex)
        {
            throw iex;
        }
        catch (Exception ex)
        {
            logger.error("Main failed - " + ex.getMessage(), ex);
        }
    }
}
