package com.deserialization.lab.processor;

import java.util.Map;
import java.util.logging.FileHandler;

import com.deserialization.lab.model.APIMessage;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;


public class DefaultPostProcessor implements Processor
{

    private final Logger logger = LogManager.getLogger(DefaultPostProcessor.class);

    @Override
    public void process(Exchange ex) throws Exception
    {
        final String body = ex.getIn().getBody(String.class);

        ObjectMapper objectMapper = new ObjectMapper();
        objectMapper.enableDefaultTyping();

        APIMessage message = objectMapper.readValue(body, APIMessage.class);

        ex.getOut().setBody(message);
    }

}
