package com.deserialization.lab.processor;

import com.deserialization.lab.model.APIMessage;
import com.deserialization.lab.model.Payload;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.net.URL;

public class PayloadGetBytesProcessor implements Processor
{

    private final Logger logger = LogManager.getLogger(PayloadGetBytesProcessor.class);

    @Override
    public void process(Exchange ex) throws Exception
    {
        final String request = ex.getIn().getBody(String.class);

        APIMessage response = new APIMessage(new Payload(new URL("http://www.google.it")), "API message!");

        ObjectMapper objectMapper = new ObjectMapper();
        objectMapper.enableDefaultTyping(ObjectMapper.DefaultTyping.NON_FINAL);

        ex.getOut().setBody(objectMapper.writeValueAsBytes(response));
    }

}
